#define DBUS_API_SUBJECT_TO_CHANGE


#include <glib.h>
#include "maman-file.h"
#include <dbus/dbus.h>
#include <dbus/dbus-glib-lowlevel.h>


static GMainLoop *loop;
static DBusConnection *dbus_connection;
static MamanFile *file;

static GMainLoop *init_glib(void)
{
	g_type_init();
	return g_main_loop_new(NULL, FALSE);
}

static void init_dbus(void)
{
	DBusError error;

	dbus_error_init(&error);
	dbus_connection = dbus_bus_get(DBUS_BUS_SESSION, &error);
	if (dbus_connection == NULL)
		g_error("Error connecting DBus: %s", error.message);

	dbus_connection_setup_with_g_main(dbus_connection, NULL);
}

static void finalize_dbus(void)
{
	dbus_connection_close(dbus_connection);
	dbus_connection_unref(dbus_connection);
}

static gboolean connect(gpointer data)
{
	g_debug("connect()");
	file = maman_file_new();
	maman_file_write(file,0,0);
	return FALSE;
}

int main(int argc, char *argv[])
{
	loop = init_glib();
	init_dbus();

	g_idle_add(connect, NULL);
	
	g_main_loop_run(loop);

	g_main_loop_unref(loop);
	finalize_dbus();

	return 0;
}
